diff -ruN qmail-1.03-orig/substdi.c qmail-1.03-ldap-20060201-orig/substdi.c
--- qmail-1.03-orig/substdi.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/substdi.c	2006-02-25 11:00:56.000000000 +0100
@@ -6,7 +6,7 @@
 register int (*op)();
 register int fd;
 register char *buf;
-register int len;
+register unsigned int len;
 {
   register int r;
 
@@ -20,9 +20,9 @@
 static int getthis(s,buf,len)
 register substdio *s;
 register char *buf;
-register int len;
+register unsigned int len;
 {
-  register int r;
+  register unsigned int r;
   register int q;
  
   r = s->p;
@@ -53,12 +53,13 @@
 int substdio_bget(s,buf,len)
 register substdio *s;
 register char *buf;
-register int len;
+register unsigned int len;
 {
-  register int r;
+  unsigned int u;
+  int r;
  
   if (s->p > 0) return getthis(s,buf,len);
-  r = s->n; if (r <= len) return oneread(s->op,s->fd,buf,r);
+  u = s->n; if (u <= len) return oneread(s->op,s->fd,buf,u);
   r = substdio_feed(s); if (r <= 0) return r;
   return getthis(s,buf,len);
 }
@@ -66,7 +67,7 @@
 int substdio_get(s,buf,len)
 register substdio *s;
 register char *buf;
-register int len;
+register unsigned int len;
 {
   register int r;
  
@@ -84,7 +85,7 @@
 
 void substdio_seek(s,len)
 register substdio *s;
-register int len;
+register unsigned int len;
 {
   s->n += len;
   s->p -= len;
diff -ruN qmail-1.03-orig/substdio.c qmail-1.03-ldap-20060201-orig/substdio.c
--- qmail-1.03-orig/substdio.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/substdio.c	2006-02-25 11:00:56.000000000 +0100
@@ -5,7 +5,7 @@
 register int (*op)();
 register int fd;
 register char *buf;
-register int len;
+register unsigned int len;
 {
   s->x = buf;
   s->fd = fd;
diff -ruN qmail-1.03-orig/substdio.h qmail-1.03-ldap-20060201-orig/substdio.h
--- qmail-1.03-orig/substdio.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/substdio.h	2006-02-25 11:00:56.000000000 +0100
@@ -3,30 +3,30 @@
 
 typedef struct substdio {
   char *x;
-  int p;
-  int n;
+  unsigned int p;
+  unsigned int n;
   int fd;
-  int (*op)();
+  int (*op)(int, void *, int);
 } substdio;
 
 #define SUBSTDIO_FDBUF(op,fd,buf,len) { (buf), 0, (len), (fd), (op) }
 
-extern void substdio_fdbuf();
+extern void substdio_fdbuf(substdio *, int (*)(int, void *, int), int, char *, unsigned int);
 
-extern int substdio_flush();
-extern int substdio_put();
-extern int substdio_bput();
-extern int substdio_putflush();
-extern int substdio_puts();
-extern int substdio_bputs();
-extern int substdio_putsflush();
-
-extern int substdio_get();
-extern int substdio_bget();
-extern int substdio_feed();
+extern int substdio_flush(substdio *);
+extern int substdio_put(substdio *, const char *, unsigned int);
+extern int substdio_bput(substdio *, const char *, unsigned int);
+extern int substdio_putflush(substdio *, const char *, unsigned int);
+extern int substdio_puts(substdio *, const char *);
+extern int substdio_bputs(substdio *, const char *);
+extern int substdio_putsflush(substdio *, const char *);
+
+extern int substdio_get(substdio *, char *, unsigned int);
+extern int substdio_bget(substdio *, char *, unsigned int);
+extern int substdio_feed(substdio *);
 
-extern char *substdio_peek();
-extern void substdio_seek();
+extern char *substdio_peek(substdio *);
+extern void substdio_seek(substdio *, unsigned int);
 
 #define substdio_fileno(s) ((s)->fd)
 
@@ -42,6 +42,6 @@
     : substdio_bput((s),&(c),1) \
   )
 
-extern int substdio_copy();
+extern int substdio_copy(substdio *, substdio *);
 
 #endif
diff -ruN qmail-1.03-orig/substdo.c qmail-1.03-ldap-20060201-orig/substdo.c
--- qmail-1.03-orig/substdo.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/substdo.c	2006-02-25 11:00:56.000000000 +0100
@@ -6,8 +6,8 @@
 static int allwrite(op,fd,buf,len)
 register int (*op)();
 register int fd;
-register char *buf;
-register int len;
+register const char *buf;
+register unsigned int len;
 {
   register int w;
 
@@ -27,7 +27,7 @@
 int substdio_flush(s)
 register substdio *s;
 {
-  register int p;
+  register unsigned int p;
  
   p = s->p;
   if (!p) return 0;
@@ -37,10 +37,10 @@
 
 int substdio_bput(s,buf,len)
 register substdio *s;
-register char *buf;
-register int len;
+register const char *buf;
+register unsigned int len;
 {
-  register int n;
+  register unsigned int n;
  
   while (len > (n = s->n - s->p)) {
     byte_copy(s->x + s->p,n,buf); s->p += n; buf += n; len -= n;
@@ -54,10 +54,10 @@
 
 int substdio_put(s,buf,len)
 register substdio *s;
-register char *buf;
-register int len;
+register const char *buf;
+register unsigned int len;
 {
-  register int n;
+  register unsigned int n;
  
   n = s->n;
   if (len > n - s->p) {
@@ -79,8 +79,8 @@
 
 int substdio_putflush(s,buf,len)
 register substdio *s;
-register char *buf;
-register int len;
+register const char *buf;
+register unsigned int len;
 {
   if (substdio_flush(s) == -1) return -1;
   return allwrite(s->op,s->fd,buf,len);
@@ -88,21 +88,21 @@
 
 int substdio_bputs(s,buf)
 register substdio *s;
-register char *buf;
+register const char *buf;
 {
   return substdio_bput(s,buf,str_len(buf));
 }
 
 int substdio_puts(s,buf)
 register substdio *s;
-register char *buf;
+register const char *buf;
 {
   return substdio_put(s,buf,str_len(buf));
 }
 
 int substdio_putsflush(s,buf)
 register substdio *s;
-register char *buf;
+register const char *buf;
 {
   return substdio_putflush(s,buf,str_len(buf));
 }
diff -ruN qmail-1.03-orig/TARGETS qmail-1.03-ldap-20060201-orig/TARGETS
--- qmail-1.03-orig/TARGETS	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/TARGETS	2006-02-25 11:00:55.000000000 +0100
@@ -147,9 +147,8 @@
 prot.o
 coe.o
 cdb_hash.o
-cdb_unpack.o
-cdb_seek.o
 cdb.a
+cdb.o
 auto-uid.o
 auto-uid
 auto-gid.o
@@ -221,10 +220,7 @@
 qmail-showctl.o
 qmail-showctl
 qmail-newu.o
-cdbmss.o
-cdbmake_pack.o
-cdbmake_hash.o
-cdbmake_add.o
+cdb_make.o
 cdbmake.a
 qmail-newu
 qmail-pw2u.o
@@ -385,3 +381,82 @@
 man
 setup
 check
+auth_imap
+Makefile.cdb-p
+auth_imap.o
+auth_mod.o
+auth_pop
+auth_pop.o
+auth_smtp
+auth_smtp.o
+auto_userl.c
+auto_userl.o
+base64.o
+byte_repl.o
+case_startb.o
+check.o
+checkpassword.o
+condwrite
+condwrite.o
+digest
+digest.o
+digest_md4.o
+digest_md5.o
+digest_rmd160.o
+digest_sha1.o
+dirmaker.o
+endian
+endian.o
+execcheck.o
+localdelivery.o
+locallookup.o
+maildir++.o
+mailmagic.o
+mailmaker.o
+output.o
+passwd.o
+pbsadd
+pbsadd.o
+pbscheck
+pbscheck.o
+pbsdbd
+pbsdbd.o
+pbsexec.o
+qldap-cluster.o
+qldap-debug.o
+qldap-errno.o
+qldap-filter.o
+qldap-profile.o
+qldap.a
+qldap.o
+qmail-cdb
+qmail-cdb.o
+qmail-forward
+qmail-forward.o
+qmail-group
+qmail-group.o
+qmail-imapd-ssl.run
+qmail-imapd.run
+qmail-ldaplookup
+qmail-ldaplookup.o
+qmail-pbsdbd.run
+qmail-pop3d-ssl.run
+qmail-pop3d.run
+qmail-qmqpd.run
+qmail-quotawarn
+qmail-quotawarn.o
+qmail-reply
+qmail-reply.o
+qmail-secretary
+qmail-secretary.o
+qmail-smtpd.run
+qmail-todo
+qmail-todo.o
+qmail-verify
+qmail-verify.o
+qmail.run
+rbl.o
+read-ctrl.o
+readwrite.o
+smtpcall.o
+xtext.o
diff -ruN qmail-1.03-orig/tcp-env.c qmail-1.03-ldap-20060201-orig/tcp-env.c
--- qmail-1.03-orig/tcp-env.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/tcp-env.c	2006-02-25 11:00:56.000000000 +0100
@@ -2,6 +2,7 @@
 #include <sys/socket.h>
 #include <sys/param.h>
 #include <netinet/in.h>
+#include <unistd.h>
 #include "sig.h"
 #include "stralloc.h"
 #include "str.h"
@@ -30,7 +31,7 @@
 
 char temp[IPFMT + FMT_ULONG];
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char *argv[];
 {
@@ -125,5 +126,5 @@
 
  sig_pipedefault();
  execvp(*argv,argv);
- die();
+ return 111;
 }
diff -ruN qmail-1.03-orig/tcpto.c qmail-1.03-ldap-20060201-orig/tcpto.c
--- qmail-1.03-orig/tcpto.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/tcpto.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,3 +1,4 @@
+#include <unistd.h>
 #include "tcpto.h"
 #include "open.h"
 #include "lock.h"
@@ -77,6 +78,7 @@
  int firstpos;
  datetime_sec lastwhen;
 
+ firstwhen = 0;
  if (!flagerr)
    if (!flagwasthere)
      return; /* could have been added, but not worth the effort to check */
diff -ruN qmail-1.03-orig/tcpto_clean.c qmail-1.03-ldap-20060201-orig/tcpto_clean.c
--- qmail-1.03-orig/tcpto_clean.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/tcpto_clean.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,3 +1,4 @@
+#include <unistd.h>
 #include "tcpto.h"
 #include "open.h"
 #include "substdio.h"
@@ -5,15 +6,15 @@
 
 char tcpto_cleanbuf[1024];
 
-void tcpto_clean() /* running from queue/mess */
+void tcpto_clean(void) /* running from queue/mess */
 {
  int fd;
- int i;
+ unsigned int i;
  substdio ss;
 
  fd = open_write("../lock/tcpto");
  if (fd == -1) return;
- substdio_fdbuf(&ss,write,fd,tcpto_cleanbuf,sizeof(tcpto_cleanbuf));
+ substdio_fdbuf(&ss,subwrite,fd,tcpto_cleanbuf,sizeof(tcpto_cleanbuf));
  for (i = 0;i < sizeof(tcpto_cleanbuf);++i) substdio_put(&ss,"",1);
  substdio_flush(&ss); /* if it fails, bummer */
  close(fd);
diff -ruN qmail-1.03-orig/tcpto.h qmail-1.03-ldap-20060201-orig/tcpto.h
--- qmail-1.03-orig/tcpto.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/tcpto.h	2006-02-25 11:00:56.000000000 +0100
@@ -1,8 +1,10 @@
 #ifndef TCPTO_H
 #define TCPTO_H
 
-extern int tcpto();
-extern void tcpto_err();
-extern void tcpto_clean();
+struct ip_address;
+
+extern int tcpto(struct ip_address *);
+extern void tcpto_err(struct ip_address *, int);
+extern void tcpto_clean(void);
 
 #endif
diff -ruN qmail-1.03-orig/timeoutconn.c qmail-1.03-ldap-20060201-orig/timeoutconn.c
--- qmail-1.03-orig/timeoutconn.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/timeoutconn.c	2006-02-25 11:00:56.000000000 +0100
@@ -10,29 +10,32 @@
 #include "byte.h"
 #include "timeoutconn.h"
 
-int timeoutconn(s,ip,port,timeout)
-int s;
-struct ip_address *ip;
-unsigned int port;
-int timeout;
+int timeoutconn(int s, struct ip_address *ip, struct ip_address *outip,
+    unsigned int port, int timeout)
 {
   char ch;
-  struct sockaddr_in sin;
+  struct sockaddr_in s_in;
   char *x;
   fd_set wfds;
   struct timeval tv;
  
-  byte_zero(&sin,sizeof(sin));
-  byte_copy(&sin.sin_addr,4,ip);
-  x = (char *) &sin.sin_port;
-  x[1] = port; port >>= 8; x[0] = port;
-  sin.sin_family = AF_INET;
  
   if (ndelay_on(s) == -1) return -1;
  
-  /* XXX: could bind s */
+  /* bind() an outgoing ipaddr */
+  byte_zero(&s_in,sizeof(s_in));
+  byte_copy(&s_in.sin_addr.s_addr,4,outip);
+  s_in.sin_family = AF_INET;
+
+  if (bind(s,(struct sockaddr *) &s_in,sizeof(s_in)) == -1) return -1;
+  
+  byte_zero(&s_in,sizeof(s_in));
+  byte_copy(&s_in.sin_addr,4,ip);
+  x = (char *) &s_in.sin_port;
+  x[1] = port; port >>= 8; x[0] = port;
+  s_in.sin_family = AF_INET;
  
-  if (connect(s,(struct sockaddr *) &sin,sizeof(sin)) == 0) {
+  if (connect(s,(struct sockaddr *) &s_in,sizeof(s_in)) == 0) {
     ndelay_off(s);
     return 0;
   }
@@ -45,9 +48,9 @@
   if (select(s + 1,(fd_set *) 0,&wfds,(fd_set *) 0,&tv) == -1) return -1;
   if (FD_ISSET(s,&wfds)) {
     int dummy;
-    dummy = sizeof(sin);
-    if (getpeername(s,(struct sockaddr *) &sin,&dummy) == -1) {
-      read(s,&ch,1);
+    dummy = sizeof(s_in);
+    if (getpeername(s,(struct sockaddr *) &s_in,&dummy) == -1) {
+      subread(s,&ch,1);
       return -1;
     }
     ndelay_off(s);
diff -ruN qmail-1.03-orig/timeoutconn.h qmail-1.03-ldap-20060201-orig/timeoutconn.h
--- qmail-1.03-orig/timeoutconn.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/timeoutconn.h	2006-02-25 11:00:56.000000000 +0100
@@ -1,6 +1,9 @@
 #ifndef TIMEOUTCONN_H
 #define TIMEOUTCONN_H
 
-extern int timeoutconn();
+struct ip_address;
+
+extern int timeoutconn(int, struct ip_address *,
+    struct ip_address *, unsigned int, int);
 
 #endif
diff -ruN qmail-1.03-orig/timeoutread.c qmail-1.03-ldap-20060201-orig/timeoutread.c
--- qmail-1.03-orig/timeoutread.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/timeoutread.c	2006-02-25 11:00:56.000000000 +0100
@@ -15,7 +15,7 @@
   FD_SET(fd,&rfds);
 
   if (select(fd + 1,&rfds,(fd_set *) 0,(fd_set *) 0,&tv) == -1) return -1;
-  if (FD_ISSET(fd,&rfds)) return read(fd,buf,len);
+  if (FD_ISSET(fd,&rfds)) return subread(fd,buf,len);
 
   errno = error_timeout;
   return -1;
diff -ruN qmail-1.03-orig/timeoutread.h qmail-1.03-ldap-20060201-orig/timeoutread.h
--- qmail-1.03-orig/timeoutread.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/timeoutread.h	2006-02-25 11:00:56.000000000 +0100
@@ -1,6 +1,6 @@
 #ifndef TIMEOUTREAD_H
 #define TIMEOUTREAD_H
 
-extern int timeoutread();
+extern int timeoutread(int, int, char *, int);
 
 #endif
diff -ruN qmail-1.03-orig/timeoutwrite.c qmail-1.03-ldap-20060201-orig/timeoutwrite.c
--- qmail-1.03-orig/timeoutwrite.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/timeoutwrite.c	2006-02-25 11:00:56.000000000 +0100
@@ -3,7 +3,7 @@
 #include "error.h"
 #include "readwrite.h"
 
-int timeoutwrite(t,fd,buf,len) int t; int fd; char *buf; int len;
+int timeoutwrite(t,fd,buf,len) int t; int fd; const void *buf; int len;
 {
   fd_set wfds;
   struct timeval tv;
@@ -15,7 +15,7 @@
   FD_SET(fd,&wfds);
 
   if (select(fd + 1,(fd_set *) 0,&wfds,(fd_set *) 0,&tv) == -1) return -1;
-  if (FD_ISSET(fd,&wfds)) return write(fd,buf,len);
+  if (FD_ISSET(fd,&wfds)) return subwrite(fd,(void *)buf,len);
 
   errno = error_timeout;
   return -1;
diff -ruN qmail-1.03-orig/timeoutwrite.h qmail-1.03-ldap-20060201-orig/timeoutwrite.h
--- qmail-1.03-orig/timeoutwrite.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/timeoutwrite.h	2006-02-25 11:00:56.000000000 +0100
@@ -1,6 +1,6 @@
 #ifndef TIMEOUTWRITE_H
 #define TIMEOUTWRITE_H
 
-extern int timeoutwrite();
+extern int timeoutwrite(int, int, const void *, int);
 
 #endif
diff -ruN qmail-1.03-orig/TLS.readme qmail-1.03-ldap-20060201-orig/TLS.readme
--- qmail-1.03-orig/TLS.readme	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/TLS.readme	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,71 @@
+Frederik Vermeulen <jos-tls@kotnet.org> 20000112
+http://www.esat.kuleuven.ac.be/~vermeule/qmail/tls.patch
+
+This patch implements RFC2487 in qmail. This means you can 
+get SSL or TLS encrypted and authenticated SMTP between 
+the MTAs and between MTA and an MUA like Netscape4.5. 
+The code is considered experimental.
+
+Usage: - install OpenSSL-0.9.4 http://www.openssl.org/
+       - apply patch to qmail-1.03 http://www.qmail.org/ 
+         Makefile and conf-cc were patched for appropriate
+         linking. Apart from that, the patches to qmail-remote.c
+         and qmail-smtpd.c can be applied separately.
+       - provide a certificate in /var/qmail/control/cert.pem.
+         "make cert" makes a self-signed certificate.
+         "make cert-req" makes a certificate request.
+       - replace qmail-smtpd and/or qmail-remote binary
+       - verify operation (header information should show
+         something like
+         "Received [..] with DES-CBC3-SHA encrypted SMTP;")
+         If you don't have a server to test with, you can test
+         by sending mail to ping@linux.student.kuleuven.ac.be,
+         which will bounce your mail.
+
+Optional: - when TLSDEBUG is defined, some extra SSL info will be logged
+          - when a 512 RSA key is provided in /var/qmail/control/rsa512.pem,
+            this key will be used instead of on-the-fly generation by
+       	    qmail-smtpd. Daily replacement can be done by crontab:
+       	    01 01 * * * /usr/local/ssl/bin/openssl genrsa \
+       	     -out /var/qmail/control/rsa512.new 512 > /dev/null 2>&1;\
+       	     chmod 600 /var/qmail/control/rsa512.new; chown qmaild.qmail \
+       	     /var/qmail/control/rsa512.new; /bin/mv -f \
+       	     /var/qmail/control/rsa512.new /var/qmail/control/rsa512.pem
+          - server authentication:
+	    qmail-remote requires authentication from servers for which
+	    /var/qmail/control/tlshosts/host.dom.ain.pem exists.
+	    The .pem file contains the validating CA certificates
+	    (or self-signed server certificate with openssl-0.9.5).
+	    CommonName has to match.
+            WARNING: this option may cause mail to be delayed, bounced,
+	    doublebounced, and lost.
+          - client authentication:
+	    when relay rules would reject an incoming mail, 
+	    qmail-smtpd can allow the mail based on a presented cert.
+	    Certs are verified against a CA list in 
+	    /var/qmail/control/clientca.pem (eg. http://www.modssl.org/
+	    source/cvs/exp/mod_ssl/pkg.mod_ssl/pkg.sslcfg/ca-bundle.crt)
+            and the cert email-address has to match a line in
+	    /var/qmail/control/tlsclients. This email-address is logged
+	    in the headers.
+
+Copyright: Same terms as qmail
+           Links with OpenSSL
+           Inspiration and code from examples in SSLeay (E. Young
+           <eay@cryptsoft.com> and T. Hudson <tjh@cryptsoft.com>),
+           stunnel (M. Trojnara <mtrojnar@ddc.daewoo.com.pl>),
+	   Postfix/TLS (L. Jaenicke <Lutz.Jaenicke@aet.tu-cottbus.de>),
+	   and modssl (R. Engelschall <rse@engelschall.com>).
+           Debug code from Jean-Philippe Donnio <jpdonnio@cpod.fr>
+           Openssl usage consulting from Bodo M"oller <bmoeller@acm.org>
+
+
+Interoperability: - Netscape 4.5 and higher
+                  - Microsoft Outlook 5
+		  - Microsoft Exchange Internet Mail Server 5.5.2448.0
+                  - Postfix/TLS
+                    http://www.aet.TU-Cottbus.DE/personen/jaenicke/pfixtls/
+                  - Sendmail-TLS http://opensource.3gi.com/sendmail-tls/
+
+Patches: mailto:<jos-tls@kotnet.org>
+
diff -ruN qmail-1.03-orig/token822.c qmail-1.03-ldap-20060201-orig/token822.c
--- qmail-1.03-orig/token822.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/token822.c	2006-02-25 11:00:56.000000000 +0100
@@ -9,10 +9,11 @@
 void token822_reverse(ta)
 token822_alloc *ta;
 {
- int i;
- int n;
+ unsigned int i;
+ unsigned int n;
  struct token822 temp;
 
+ if (ta->len == 0) return;
  n = ta->len - 1;
  for (i = 0;i + i < n;++i)
   {
@@ -65,7 +66,7 @@
 static void atomcheck(t)
 struct token822 *t;
 {
- int i;
+ unsigned int i;
  char ch;
  for (i = 0;i < t->slen;++i)
   {
@@ -84,10 +85,10 @@
 unsigned int linelen;
 {
  struct token822 *t;
- int len;
+ unsigned int len;
  int ch;
- int i;
- int j;
+ unsigned int i;
+ unsigned int j;
  int lasttype;
  int newtype;
  char *s;
@@ -145,7 +146,7 @@
        *s++ = ',';
 #define NSUW \
  s[0] = '\n'; s[1] = ' '; \
- if (linee && (!linelen || (s - lineb <= linelen))) \
+ if (linee && (!linelen || ((unsigned long)(s - lineb) <= linelen))) \
   { while (linee < s) { linee[0] = linee[2]; ++linee; } linee -= 2; } \
  else { if (linee) lineb = linee + 1; linee = s; s += 2; }
        NSUW
@@ -184,9 +185,9 @@
 token822_alloc *ta;
 {
  struct token822 *t;
- int len;
- int i;
- int j;
+ unsigned int len;
+ unsigned int i;
+ unsigned int j;
  char *s;
 
  len = 0;
@@ -240,12 +241,12 @@
 stralloc *sa;
 stralloc *buf;
 {
- int i;
- int salen;
- int level;
+ unsigned int i;
+ unsigned int salen;
+ unsigned int level;
  struct token822 *t;
- int numtoks;
- int numchars;
+ unsigned int numtoks;
+ unsigned int numchars;
  char *cbuf;
 
  salen = sa->len;
@@ -403,7 +404,7 @@
 token822_alloc *taaddr;
 int (*callback)();
 {
- int i;
+ unsigned int i;
 
  if (callback(taaddr) != 1)
    return 0;
diff -ruN qmail-1.03-orig/token822.h qmail-1.03-ldap-20060201-orig/token822.h
--- qmail-1.03-orig/token822.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/token822.h	2006-02-25 11:00:56.000000000 +0100
@@ -4,23 +4,28 @@
 struct token822
  {
   int type;
-  char *s;
-  int slen;
+  const char *s;
+  unsigned int slen;
  }
 ;
 
 #include "gen_alloc.h"
+#include "stralloc.h"
+
 GEN_ALLOC_typedef(token822_alloc,struct token822,t,len,a)
 
-extern int token822_parse();
-extern int token822_addrlist();
-extern int token822_unquote();
-extern int token822_unparse();
+extern int token822_parse(token822_alloc *, stralloc *, stralloc *);
+extern int token822_addrlist(token822_alloc *, token822_alloc *,
+    token822_alloc *, int (*)());
+extern int token822_unquote(stralloc *, token822_alloc *);
+extern int token822_unparse(stralloc *, token822_alloc *, unsigned int);
+/* XXX not available in qmail-1.03
 extern void token822_free();
-extern void token822_reverse();
-extern int token822_ready();
-extern int token822_readyplus();
-extern int token822_append();
+*/
+extern void token822_reverse(token822_alloc *);
+extern int token822_ready(token822_alloc *, unsigned int);
+extern int token822_readyplus(token822_alloc *, unsigned int);
+extern int token822_append(token822_alloc *, struct token822 *);
 
 #define TOKEN822_ATOM 1
 #define TOKEN822_QUOTE 2
diff -ruN qmail-1.03-orig/trigger.c qmail-1.03-ldap-20060201-orig/trigger.c
--- qmail-1.03-orig/trigger.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/trigger.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,3 +1,4 @@
+#include <unistd.h>
 #include "select.h"
 #include "open.h"
 #include "trigger.h"
@@ -8,7 +9,7 @@
 static int fdw = -1;
 #endif
 
-void trigger_set()
+void trigger_set(void)
 {
  if (fd != -1)
    close(fd);
diff -ruN qmail-1.03-orig/trigger.h qmail-1.03-ldap-20060201-orig/trigger.h
--- qmail-1.03-orig/trigger.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/trigger.h	2006-02-25 11:00:56.000000000 +0100
@@ -1,8 +1,10 @@
 #ifndef TRIGGER_H
 #define TRIGGER_H
 
-extern void trigger_set();
-extern void trigger_selprep();
-extern int trigger_pulled();
+#include "select.h"
+
+extern void trigger_set(void);
+extern void trigger_selprep(int *, fd_set *);
+extern int trigger_pulled(fd_set *);
 
 #endif
diff -ruN qmail-1.03-orig/triggerpull.c qmail-1.03-ldap-20060201-orig/triggerpull.c
--- qmail-1.03-orig/triggerpull.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/triggerpull.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,8 +1,10 @@
+#include <unistd.h>
+#include "readwrite.h"
 #include "ndelay.h"
 #include "open.h"
 #include "triggerpull.h"
 
-void triggerpull()
+void triggerpull(void)
 {
  int fd;
 
diff -ruN qmail-1.03-orig/triggerpull.h qmail-1.03-ldap-20060201-orig/triggerpull.h
--- qmail-1.03-orig/triggerpull.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/triggerpull.h	2006-02-25 11:00:56.000000000 +0100
@@ -1,6 +1,6 @@
 #ifndef TRIGGERPULL_H
 #define TRIGGERPULL_H
 
-extern void triggerpull();
+extern void triggerpull(void);
 
 #endif
diff -ruN qmail-1.03-orig/wait.h qmail-1.03-ldap-20060201-orig/wait.h
--- qmail-1.03-orig/wait.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/wait.h	2006-02-25 11:00:56.000000000 +0100
@@ -1,11 +1,12 @@
 #ifndef WAIT_H
 #define WAIT_H
 
-extern int wait_pid();
-extern int wait_nohang();
+extern int wait_pid(int *, int);
+extern int wait_nohang(int *);
+/* XXX not available in qmail-1.03
 extern int wait_stop();
 extern int wait_stopnohang();
-
+*/
 #define wait_crashed(w) ((w) & 127)
 #define wait_exitcode(w) ((w) >> 8)
 #define wait_stopsig(w) ((w) >> 8)
diff -ruN qmail-1.03-orig/xtext.c qmail-1.03-ldap-20060201-orig/xtext.c
--- qmail-1.03-orig/xtext.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/xtext.c	2006-02-25 11:00:56.000000000 +0100
@@ -0,0 +1,85 @@
+/*
+ * Copyright (c) 2005 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+
+#include "stralloc.h"
+#include "xtext.h"
+
+static int xtext_doit(stralloc *, stralloc *);
+static const char ioHexArray[] = "0123456789abcdef";
+
+static int
+xtext_doit(stralloc *saout, stralloc *sain)
+{
+	unsigned int	n;
+	char		x[3];
+	unsigned char	c;
+
+	if (!stralloc_ready(saout,sain->len))
+		return (0);
+	x[0] = '+';
+	for (n = 0; n < sain->len; n++) {
+		c = sain->s[n];
+		if (c < 33 || c > 126 || c == '=' || c == '+') {
+			x[1] = ioHexArray[(c >> 4) & 0x0f];
+			x[2] = ioHexArray[c & 0x0f];
+			if (!stralloc_catb(saout, x, sizeof(x)))
+				return (0);
+		} else
+			if (!stralloc_append(saout, &c))
+				return (0);
+	}
+	return (1);
+}
+
+int
+xtext_needed(const char *s, unsigned int n)
+{
+	unsigned char	c;
+
+	for (; n > 0; n--) {
+		c = *s++;
+		if (c < 33 || c > 126 || c == '=' || c == '+')
+			return (1);
+	}
+	return (0);
+}
+
+int
+xtext_quote(stralloc *saout, stralloc *sain)
+{
+	if (xtext_needed(sain->s, sain->len))
+		return (xtext_doit(saout, sain));
+	return (stralloc_copy(saout,sain));
+}
+
diff -ruN qmail-1.03-orig/xtext.h qmail-1.03-ldap-20060201-orig/xtext.h
--- qmail-1.03-orig/xtext.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/xtext.h	2006-02-25 11:00:56.000000000 +0100
@@ -0,0 +1,40 @@
+/*
+ * Copyright (c) 2005 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#ifndef _XTEXT_H_
+#define _XTEXT_H_
+
+int xtext_needed(const char *, unsigned int);
+int xtext_quote(stralloc *, stralloc *);
+
+#endif
